Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions

# SSWriter Class Reference

An internal class for writing to a socket stream. More...

Inheritance diagram for SSWriter:

List of all members.

## Public Member Functions
| close ()
bool | considerFlush ()
| Sends the most recently queued data if enough time has elapsed.
bool | flush ()
| Sends the most recently queued data now.
bool | getCollectTcp ()
| Returns the current setting of "collect-tcp" mode.
double | getCollectTcpInterval ()
| Returns the interval in time, in seconds, for which to hold TCP packets before sending all of the recently received packets at once.
int | getTcpHeaderSize ()
| Returns the header size for datagrams.
bool | isClosed ()
bool | sendDatagram (Datagram const dg)
| Transmits the indicated datagram over the socket by prepending it with a little-endian 16-bit byte count.
| setCollectTcp (bool collect_tcp)
| Enables or disables "collect-tcp" mode.
| setCollectTcpInterval (double interval)
| Specifies the interval in time, in seconds, for which to hold TCP packets before sending all of the recently received packets at once.
| setTcpHeaderSize (int tcp_header_size)
| Sets the header size for datagrams.

## Detailed Description

An internal class for writing to a socket stream.

This serves as a base class for both OSocketStream and SocketStream; its purpose is to minimize redundant code between them. Do not use it directly.

## Member Function Documentation

close | ( |  | ) |

Reimplemented in OSocketStream, and SocketStream.

bool considerFlush | ( |  | ) |

Sends the most recently queued data if enough time has elapsed.

This only has meaning if set_collect_tcp() has been set to true.

bool flush | ( |  | ) |

Sends the most recently queued data now.

This only has meaning if set_collect_tcp() has been set to true.

Reimplemented in OSocketStream, and SocketStream.

bool getCollectTcp | ( |  | ) |

Returns the current setting of "collect-tcp" mode.

See set_collect_tcp().

double getCollectTcpInterval | ( |  | ) |

Returns the interval in time, in seconds, for which to hold TCP packets before sending all of the recently received packets at once.

This only has meaning if "collect-tcp" mode is enabled; see set_collect_tcp().

int getTcpHeaderSize | ( |  | ) |

Returns the header size for datagrams.

See set_tcp_header_size().

Reimplemented in SocketStream.

bool isClosed | ( |  | ) |

Reimplemented in OSocketStream, and SocketStream.

bool sendDatagram | ( | Datagram const | dg | ) |

Transmits the indicated datagram over the socket by prepending it with a little-endian 16-bit byte count.

Does not return until the data is sent or the connection is closed, even if the socket stream is non-blocking.

setCollectTcp | ( | bool | collect_tcp | ) |

Enables or disables "collect-tcp" mode.

In this mode, individual TCP packets are not sent immediately, but rather they are collected together and accumulated to be sent periodically as one larger TCP packet. This cuts down on overhead from the TCP/IP protocol, especially if many small packets need to be sent on the same connection, but it introduces additional latency (since packets must be held before they can be sent).

See set_collect_tcp_interval() to specify the interval of time for which to hold packets before sending them.

If you enable this mode, you may also need to periodically call consider_flush() to flush the queue if no packets have been sent recently.

setCollectTcpInterval | ( | double | interval | ) |

Specifies the interval in time, in seconds, for which to hold TCP packets before sending all of the recently received packets at once.

This only has meaning if "collect-tcp" mode is enabled; see set_collect_tcp().

setTcpHeaderSize | ( | int | tcp_header_size | ) |

Sets the header size for datagrams.

At the present, legal values for this are 0, 2, or 4; this specifies the number of bytes to use encode the datagram length at the start of each TCP datagram. Sender and receiver must independently agree on this.

Reimplemented in SocketStream.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties